module Bideo
  class Client
    attr_reader :url, :download_urls, :session, :file_names, :save_directory

    def initialize(url = "")
      @session = SecureRandom.hex(8)
      @file_names = ViddlRb.get_names(url)
      @url = url
      @download_urls = ViddlRb.get_urls_exts(url)
    end

    def download(path = "#{Dir.pwd}/tmp" )
      @save_directory = "#{path}/#{self.session}"

      urls_and_file_names = self.download_urls.zip(self.file_names)
      Dir.mkdir(@save_directory)

      urls_and_file_names.each do |download_url, file_name|
        open("#{@save_directory}/#{file_name}", "wb") do |file|
          open(download_url[:url]) do |uri|
            file.write(uri.read)
          end
        end
      end

      self
    end
  end
end
